"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.from");

require("core-js/modules/es.array.is-array");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.map");

require("core-js/modules/es.array.slice");

require("core-js/modules/es.date.to-string");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var Selections = function () {
  var getLineChange = function getLineChange(bars, barView, i) {
    var isNotLast = function isNotLast(arr, pos) {
      return pos < arr.length - 1;
    };

    while (isNotLast(bars, i) && bars[i].dimensions.y === bars[i + 1].dimensions.y) {
      i++;
    }

    var dims = [{
      x: bars[i].dimensions.x + barView.bar.width,
      y: bars[i].dimensions.y
    }];
    if (isNotLast(bars, i)) dims.push({
      x: bars[i + 1].dimensions.x,
      y: bars[i + 1].dimensions.y
    });
    return {
      i: i,
      dims: dims
    };
  };

  var getRectsDims = function getRectsDims(bars, barView, startX, selection) {
    var rectsDims = []; //start x,y

    var startBar = bars[selection.start.bar].dimensions;
    var startChordX = startX[selection.start.bar][selection.start.chord];
    var x = startBar.x + startChordX;
    var y = startBar.y; //end x,y

    var endBar = bars[selection.end.bar].dimensions;
    var endY = endBar.y;
    var endBarChordsX = startX[selection.end.bar];
    var endX = selection.end.chord === endBarChordsX.length - 1 ? endBar.x + barView.bar.width : endBar.x + endBarChordsX[selection.end.chord + 1];
    if (y === endY) rectsDims.push({
      x: x,
      y: y,
      endX: endX,
      endY: endY
    });else {
      var prevDims, i, dims;
      var isFirst = true,
          lineChanges = [];
      var tmpY = y;
      var iBar = selection.start.bar;

      while (tmpY !== endY) {
        var _getLineChange = getLineChange(bars, barView, iBar);

        i = _getLineChange.i;
        dims = _getLineChange.dims;
        iBar = i + 1;
        tmpY = dims[1].y;

        if (isFirst) {
          isFirst = false;
          rectsDims.push({
            x: x,
            y: y,
            endX: dims[0].x,
            endY: dims[0].y
          });
        } else {
          rectsDims.push({
            x: prevDims.x,
            y: prevDims.y,
            endX: dims[0].x,
            endY: dims[0].y
          });
        }

        prevDims = dims[1];
      }

      rectsDims.push({
        x: prevDims.x,
        y: prevDims.y,
        endX: endX,
        endY: endY
      });
    }
    return rectsDims;
  };

  var getRects = function getRects(bars, barView, startX, selections) {
    var totalRectsDims = [],
        rectsDims;

    var _iterator = _createForOfIteratorHelper(selections),
        _step;

    try {
      var _loop = function _loop() {
        var selection = _step.value;
        rectsDims = getRectsDims(bars, barView, startX, selection).map(function (dims, i) {
          var color = selection.color || "#00F";
          return {
            x: dims.x,
            y: dims.y,
            width: dims.endX - dims.x,
            height: barView.bar.height,
            fill: color,
            fillOpacity: 0.3,
            stroke: color,
            strokeOpacity: 1
          };
        });
        totalRectsDims = [].concat(_toConsumableArray(totalRectsDims), _toConsumableArray(rectsDims));
      };

      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        _loop();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    return totalRectsDims;
  };

  return {
    getRects: getRects,
    getRectsDims: getRectsDims,
    getLineChange: getLineChange
  };
}();

var _default = Selections;
exports["default"] = _default;